<%@ page import="java.util.*" %>
<%@ page import="com.opencms.file.*" %>
<%@ page import="com.opencms.core.*" %>
<%@ page import="com.opencms.flex.jsp.*" %>
<%@ page session="false" %>
<%@ taglib prefix="cms" uri="http://www.opencms.org/taglib/cms" %>

<jsp:useBean id="newsBean" scope="page" class="com.opencms.modules.homepage.news.NewsBean" />
<jsp:useBean id="newsItem" scope="page" class="com.opencms.modules.homepage.news.NewsItem" />

<cms:template element="head">
  <cms:include file="/system/modules/ch.hema.www/jsptemplates/hema.jsp" element="head"/>
</cms:template>

<cms:template element="body">
<%
        // Create a JSP action and object elements
        com.opencms.flex.jsp.CmsJspActionElement cms= new CmsJspActionElement(pageContext, request, response);
        com.opencms.file.CmsObject cmsObj = cms.getCmsObject();


        CmsFile newFile;
        String sourceFolder, sourceFile, targetFolder, targetFile, targetURL;
        byte[] fileContents;
        String fileContentsAsString;


        // Uses the following properties of THIS file - Otherwise sets to defaults
        //   NewsItemTemplateFolder   - The folder where the item template can be found
        //   NewsItemTemplateFile     - The filename of the item template
        //   NewsItemArchiveFolder    - The folder where the news item archives are to be written

        // If you call this file from somewhere else (another jsp), you will have to set this manually
        //   this allows the file to get the properties defined above
        //String thisFile = cms.getRequestContext().getUri();
        String thisFile = "/system/modules/ch.hema.www/news/newsStatic.jsp";

        // --------------------------------------------
        // Get the passed parameters (if any)
        String id = request.getParameter("id");
        String tempNumOfItems = request.getParameter("numOfItems");
        String tempTextLength = request.getParameter("textLength");

        int numOfItems, textLength;

        try
        {
          if (tempNumOfItems != null) {numOfItems = new Integer(tempNumOfItems).intValue();} else {numOfItems = 0;}
        }
        catch(NumberFormatException e) { numOfItems = 0; }

        try
        {
          // -1 = no text     0 = all text   x>0 = text of length x
          if (tempTextLength != null) {textLength = new Integer(tempTextLength).intValue();} else {textLength = -1;}
        }
        catch(NumberFormatException e) { textLength = -1; }
        // --------------------------------------------

        // This is the name of the template file
        sourceFolder = cms.property("NewsItemTemplateFolder",thisFile, cms.getRequestContext().currentFolder().getPath());
        sourceFile = cms.property("NewsItemTemplateFile",thisFile, "newsItemTemplate.jsp");
        targetFolder = cms.property("NewsItemArchiveFolder",thisFile, cms.getRequestContext().currentFolder().getPath()+"archive/");

        // Remove all pages from archive (if you want to then do it here)
        // -----------

        // Loop through all news items
        Vector newslist = null;
        if (id != null) {
            int i = Integer.parseInt(id);
            newslist = newsBean.getList(i);
        } else {
            newslist = newsBean.getList();
        }
        
        int y = newslist.size();
        if (numOfItems > 0 && numOfItems < y) {y = numOfItems;}
    
        for (int x=0; x < y; x++) {
            newsItem = (com.opencms.modules.homepage.news.NewsItem)newslist.elementAt(x);

            // Set the target filename and url
            targetFile = "news_"+newsItem.getID()+".html";
            targetURL = targetFolder+targetFile;

            try
            {
              // Copy the template text file to our new news file
              cmsObj.copyResource( sourceFolder+sourceFile, targetFolder+targetFile );
            }
            catch(CmsException e)
            {
              //out.print("\n<!-- cmsNews:Could not copy "+sourceFolder+sourceFile+" to "+targetFolder+targetFile+" : "+e+" -->");
            }

            try
            {
              // Now get the resource,
              cmsObj.lockResource(targetFolder+targetFile,true);
              newFile = cmsObj.readFile(targetFolder+targetFile);
              fileContents = newFile.getContents();

              // Convert byte array to string
              fileContentsAsString = new String(fileContents);
              
              // Replace the %NEWSID%
              fileContentsAsString = fileContentsAsString.replaceAll("%NEWSID%",Integer.toString(newsItem.getID()) );

              // Convert back to byte array and save
              fileContents = fileContentsAsString.getBytes();
              newFile.setContents(fileContents);
              cmsObj.writeFile(newFile);
              cmsObj.unlockResource(targetFolder+targetFile);
            }
            catch(Exception e)
            {
              //out.print("\n<!-- cmsNews:Could not replace NEWSID in "+targetFolder+targetFile+" : "+e+" -->");
            }

            out.print("<p><a href=\""+cms.link(targetURL)+"\">"+newsItem.getHeadline()+"</a>");
            if (textLength >= 0)
            {
              if ( textLength > 0 && textLength < newsItem.getN_text().length() )
              {
                out.print("<ul><li>"+newsItem.getN_text().substring(1,textLength)+"</li></ul>");
              }
              else
              {
                out.print("<ul><li>"+newsItem.getN_text()+"</li></ul>");
              }
            }
            out.print("</p>");
        }
%>
</cms:template>

<cms:template element="foot">
  <cms:include file="/system/modules/ch.hema.www/jsptemplates/hema.jsp" element="foot"/>
</cms:template>
